#include <string.h>

void makeVersionNr(char* version_string, char* cvs_version) {

  strncpy(version_string, strchr(cvs_version, ' '), 
          strrchr(cvs_version, ' ') - strchr(cvs_version, ' '));

}

void makeReleaseNr(char* release_string, char* cvs_release) {

  if (strchr(cvs_release, '_')) {
    /* We expect Name to correspond to <STRING>_<MAJOR VERSION>_<MINOR VERSION> */
    strncpy(release_string, strchr(cvs_release, '_') + 1, 
            strrchr(cvs_release, ' ') - strchr(cvs_release, '_'));
    if (strrchr(release_string, ' ')) *strchr(release_string, ' ') = '\0';
    if (strchr(release_string, '_')) *strchr(release_string, '_') = '.';
  }

}

char* substitute (const char * input)
{
  static char buf[1025];
  int x = 0;  
  while (*input && x < 1013) {
    switch (*input) {
    case '_':
    case '&':
    case '#':
    case '$':
    case '%':
    case '{':
    case '}':
      buf[x++] = '\\';
      buf[x++] = *input;
      break;
    case '\\':
      buf[x++] = '{';
      buf[x++] = '\\';
      buf[x++] = 't';
      buf[x++] = 't';
      buf[x++] = '\\';
      buf[x++] = 's';
      buf[x++] = 'y';
      buf[x++] = 'm';
      buf[x++] = 'b';
      buf[x++] = 'o';
      buf[x++] = 'l';
      buf[x++] = '{';
      buf[x++] = '9';
      buf[x++] = '2';
      buf[x++] = '}';
      buf[x++] = '}';
      break;
    case '^':
      buf[x++] = '\\';
      buf[x++] = 's';
      buf[x++] = 'y';
      buf[x++] = 'm';
      buf[x++] = 'b';
      buf[x++] = 'o';
      buf[x++] = 'l';
      buf[x++] = '{';
      buf[x++] = '9';
      buf[x++] = '4';
      buf[x++] = '}';
      break;
    case '~':
      buf[x++] = '\\';
      buf[x++] = 's';
      buf[x++] = 'y';
      buf[x++] = 'm';
      buf[x++] = 'b';
      buf[x++] = 'o';
      buf[x++] = 'l';
      buf[x++] = '{';
      buf[x++] = '1';
      buf[x++] = '2';
      buf[x++] = '6';
      buf[x++] = '}';
      break;
    default:
      buf[x++] = *input;
      break;
    }
    input++;
  }
  buf[x] = '\0';
  return buf;
}

char* html_substitute (const char * input)
{
  static char buf[1025];
  int x = 0;  
  while (*input && x < 1013) {
    switch (*input) {
      /* latex2html seem's to have some problems with this ...
    case '"':
      buf[x++] = '&';
      buf[x++] = '#';
      buf[x++] = '3';
      buf[x++] = '4';
      buf[x++] = ';';
      break;
      */
    case '&':
      buf[x++] = '&';
      buf[x++] = '#';
      buf[x++] = '3';
      buf[x++] = '8';
      buf[x++] = ';';
      break;
    case '<':
      buf[x++] = '&';
      buf[x++] = '#';
      buf[x++] = '6';
      buf[x++] = '0';
      buf[x++] = ';';
      break;
    case '>':
      buf[x++] = '&';
      buf[x++] = '#';
      buf[x++] = '6';
      buf[x++] = '2';
      buf[x++] = ';';
      break;
    default:
      buf[x++] = *input;
      break;
    }
    input++;
  }
  buf[x] = '\0';
  return buf;
}
